Poj 3280 Cheapest Palindrome【区间dp】

来源:互联网 发布:c 结构体数组赋值 编辑:程序博客网 时间:2024/06/11 17:04

Cheapest Palindrome
Time Limit: 2000MS Memory Limit: 65536KTotal Submissions: 7823 Accepted: 3793

Description

Keeping track of all the cows can be a tricky task so Farmer John has installed a system to automate it. He has installed on each cow an electronic ID tag that the system will read as the cows pass by a scanner. Each ID tag's contents are currently a single string with length M (1 ≤ M ≤ 2,000) characters drawn from an alphabet of N (1 ≤ N ≤ 26) different symbols (namely, the lower-case roman alphabet).

Cows, being the mischievous creatures they are, sometimes try to spoof the system by walking backwards. While a cow whose ID is "abcba" would read the same no matter which direction the she walks, a cow with the ID "abcb" can potentially register as two different IDs ("abcb" and "bcba").

FJ would like to change the cows's ID tags so they read the same no matter which direction the cow walks by. For example, "abcb" can be changed by adding "a" at the end to form "abcba" so that the ID is palindromic (reads the same forwards and backwards). Some other ways to change the ID to be palindromic are include adding the three letters "bcb" to the begining to yield the ID "bcbabcb" or removing the letter "a" to yield the ID "bcb". One can add or remove characters at any location in the string yielding a string longer or shorter than the original string.

Unfortunately as the ID tags are electronic, each character insertion or deletion has a cost (0 ≤ cost ≤ 10,000) which varies depending on exactly which character value to be added or deleted. Given the content of a cow's ID tag and the cost of inserting or deleting each of the alphabet's characters, find the minimum cost to change the ID tag so it satisfies FJ's requirements. An empty ID tag is considered to satisfy the requirements of reading the same forward and backward. Only letters with associated costs can be added to a string.

Input

Line 1: Two space-separated integers: N and M 
Line 2: This line contains exactly M characters which constitute the initial ID string 
Lines 3..N+2: Each line contains three space-separated entities: a character of the input alphabet and two integers which are respectively the cost of adding and deleting that character.

Output

Line 1: A single line with a single integer that is the minimum cost to change the given name tag.

Sample Input

3 4abcba 1000 1100b 350 700c 200 800

Sample Output

900

Hint

If we insert an "a" on the end to get "abcba", the cost would be 1000. If we delete the "a" on the beginning to get "bcb", the cost would be 1100. If we insert "bcb" at the begining of the string, the cost would be 350 + 200 + 350 = 900, which is the minimum.

Source

USACO 2007 Open Gold

题意:

给出一个字符串,给出增加和删除某个字符需要的费用,问把这个字符串处理成回文的字符串至少需要多少费用


题解:

dp[i][j] 表示把字符串的i~j 段处理成回文串,至少需要多少费用

1,如果s[i]=s[j],那么dp[i][j]=dp[i+1][j-1],就是没有额外的花费

2,如果s[i]!=s[j],那么就需要计算处理哪一端的字符更节省了,两端的花费进行比较。

即:dp[i][j]=min(dp[i][j-1]+cost(j),dp[i+1][j]+cost(i));


因为对某个数删除或者添加并不影响动态的选取,因此只需要保留对某种元素操作的最小代价就可以了!

另外可以用滚动数组进行优化一下..



传说中的区间DP,确实不会做,感觉好像听懂了,下次做估计还是不会做.........


#include<cstdio>#include<cstring>#include<algorithm>using namespace std;int dp[2005][2005],tab[30];char s[2005];int slove(int n,int m){memset(dp,0,sizeof(dp));for(int i=m-1;i>=0;--i) {for(int j=i+1;j<m;++j){if(s[i]==s[j]){dp[i][j]=dp[i+1][j-1];}else{dp[i][j]=min(dp[i+1][j]+tab[s[i]-'a'],dp[i][j-1]+tab[s[j]-'a']);}}}return dp[0][m-1];}int main(){int n,m;//freopen("shuju.txt","r",stdin);while(~scanf("%d%d",&n,&m)){scanf("%s",s);for(int i=0;i<n;++i){char ch;int a,b;scanf(" %c%d%d",&ch,&a,&b);tab[ch-'a']=min(a,b);}printf("%d\n",slove(n,m));}return 0;}


0 0
原创粉丝点击